<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"
          "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>

<HEAD>
<TITLE>JFLA 99</TITLE>
</HEAD>

<BODY BGCOLOR="#FFFFFF">

<H1 ALIGN=CENTER>JFLA 99: relecture du papier 6</H1>

<P>
Nom du papier et auteurs:
Un cadre generique de definition d'analyseurs a partir de specifications
operationnelles
Valerie Gouranton

<H2>1</H2>

<P>
Nom du rapporteur: Damien Doligez

<P>Confiance en la note: 1

<P>Notation du papier: 2

<P>Commentaires aux auteurs:



<P>Commentaires réservés au comité de programme:

<P>Alain Deutsch dit:
<P>1. que c'est moins puissant que les trucs publies par Nielson & Nielson
<P>2. que l'exemple des variables vivantes est particulierement faible
<P>3. que ce papier est subsume par la reference [6]

<P>Moi j'y comprends pas grand-chose.

<H2>2</H2>

<P>
Nom du rapporteur: Pierre Weis

<P>Confiance en la note: 1

<P>Notation du papier: 2

<P>Commentaires aux auteurs:



<P>Commentaires réservés au comité de programme:
<P>Le papier est vraiment difficile à comprendre. On se demande s'il faut
vraiment mettre en place un tel formalisme pour réaliser les analyses
décrites. On parvient à peine à savoir s'il s'agit d'une méthode
entièrement ou semi automatique ou s'il s'agit simplement de donner
l'idée de ce qui pourrait être une méthodologie d'obtention d'analyseurs.
<P>
Ce papier a-t-il sa place aux JFLA ?


<H2>3</H2>

<P>Nom du rapporteur: Jean Goubault-Larrecq

<P>Confiance en la note: (de 1 à 3) 3
<P> (1 : je n'ai pas compris car ce n'est pas mon domaine.
<P>  2 : j'ai compris, mais je ne domine pas le sujet.
<P>  3 : j'ai tout compris car c'est mon domaine.)

<P>Notation du papier: (de 1 à 5) 2
<P> (1: à rejeter; 2: inintéressant; 3: acceptable;
<P>  4: bon papier; 5: très bon papier)

<P>Commentaires aux auteurs:
<P>    Cet article n'apporte pas vraiment grand-chose de nouveau
dans le domaine de l'analyse statique de programmes, malheureusement.
D'autre part, les idées mises en avant dans cet article ne sont
jamais développées jusqu'à leur conclusion logique.  Par exemple,
c'est une bonne idée que de concevoir une analyse en deux temps,
par dérivation d'une analyse dynamique qui est ensuite abstraite,
mais l'auteur peut difficilement pretendre qu'il s'agisse d'une nouveauté.
L'intérêt de l'auteur était ici de démontrer l'intérêt de ses
idées,
que ce soit en décrivant un outil générique produisant des analyseurs
(quasi-) automatiquement à partir d'un certain nombre de choix entrés par
l'utilisateur (choix des domaines, des fonctions d'abstraction et de
concrétisation, des fonctions sémantiques qui seront approchées,
et aussi des élargissements, pourquoi pas), ou que ce soit par la
démonstration d'une facilité accrue d'écriture de preuves de correction
dans un outil de preuve formelle comme Coq par exemple.  L'auteur avait
naturellement d'autres choix pour évaluer et démontrer l'intérêt de
son approche, mais aucun avantage clair de sa méthode n'est dégagé.
<P>    Il reste que cet article pourrait servir d'introduction agréable aux
principes de l'interprétation abstraite, et il est en particulier louable que
l'auteur ait bien expliqué certains principes ignorés de nombre de
chercheurs dans le domaine; je pense en particulier à la séparation
entre la génération des équations sémantiques de leur résolution,
une idée déjà utilisée par Cousot et Halbwachs en 1979.
Seulement, l'auteur emploie des notations lourdes qui ne facilitent pas
la lecture (les notations de sélections de champs en cascade), et la
définition de la fonction d'exemple $\alpha_P$ est parachutée.  Bien
que je m'y connaisse dans le domaine, il m'a fallu quelque temps ne
serait-ce que pour comprendre qu'il s'agissait de la fonction dont on
cherche a calculer le point fixe.  De plus, les astuces algorithmiques
Lispiennes
consistant à factoriser le code sur des bases non sémantiquement
pertinentes diminient grandement la lisibilité du code (par exemple,
la distinction entre règles zéro-aires, unaires et binaires n'a pas
de fondement sémantique, et l'utilisation de cette distinction dans
le code de $\alpha_P$ rend cette dernière assez illisible, malgré les
explications données par la suite en page 10).  C'est dommage, sinon
l'article serait une bonne base de cours.
<P>    D'un point de vue technique, la méthodologie de l'auteur semble
quand même un peu limitée.  D'abord, elle privilégie naturellement
les analyses en arrière.  Même si je suis convaincu qu'on peut
coder aussi des analyses en avant (ou dans des directions mixtes,
comme l'analyse modale de Bernhard Steffen le permet), c'est moins
naturel.  Ensuite, le problème de l'arrêt de l'analyse, avec tous
ses corollaires, n'est pas examiné~: dans le cas où le treillis d'analyse
n'est pas fini (il est fini dans l'exemple donné), comment choisit-on
les élargissements, où les insère-t-on, peut-on raffiner une analyse
arrière avec élargissement par une analyse avant ultérieure utilisant
un rétrécissement, etc.?
<P>    Un dernier point: la paire $(Abs_a, Conc_a)$ doit être une paire de
fonctions monotones pour que la théorie fonctionne.  Ce n'est pas
précisé dans le papier.  De plus, il n'est absolument pas indispensable
de disposer d'une interprétation de Galois dans le cas général.
Le seul intérêt de disposer d'une interprétation de Galois est que,
étant donnée la concrétisation, il existe une et une unique meilleure
abstraction possible.  Il existe des cas (de plus en plus nombreux)
d'analyses où il n'y pas de meilleure abstraction possible (il y a
des cha\^{\i}nes infinies croissantes d'abstractions de plus en
plus précises, c'est tout).  Dans ce cas, on ne dispose que d'une
fonction de concrétisation---ce qui n'est déjà pas si mal---
mais alors on ne rentre plus dans le cadre du papier.

<P>Commentaires réservés au comité de programme:
</BODY>
</HTML>
